﻿package {
	import flash.display.Sprite;
	import flash.media.Sound;
	import flash.utils.ByteArray;
	import flash.events.Event;
	import flash.media.SoundMixer;
	import flash.filters.GlowFilter;
	import flash.net.URLRequest;
	import flash.events.MouseEvent;
	import flash.media.SoundChannel;

	public class Main extends Sprite{
		private var sound:Sound;
		private var channel:SoundChannel;
		private var byteArr:ByteArray = new ByteArray();
		private var glow:GlowFilter = new GlowFilter();
		private var filterArr:Array;
		private var line:Sprite = new Sprite();
		private var num:Number;
		public const GRAFT_HEIGHT:int = 150;
		public const CHANNEL_SIZE:int = 256;

		public function Main(){
			glow.color = 0x009900;
			glow.alpha = 1;
			glow.blurX = 8;
			glow.blurY = 8;
			
			sound = new Sound(new URLRequest("../sound.mp3"));
			
			filterArr = new Array(glow);
			line.filters = filterArr;
			addChild(line);
			
			play_btn.addEventListener(MouseEvent.CLICK,onPlayHandler);
			stop_btn.addEventListener(MouseEvent.CLICK,onStopHandler);
		}
		
		private function onPlayHandler(event:MouseEvent):void{
			channel = sound.play(0,1000);
			addEventListener(Event.ENTER_FRAME,spectrumHandler);
		}
		
		private function onStopHandler(event:MouseEvent):void{
			channel.stop();
			line.graphics.clear();
			removeEventListener(Event.ENTER_FRAME,spectrumHandler);
		}

		private function spectrumHandler(event:Event):void{
			num = 0;
			
			line.graphics.clear();
			line.graphics.lineStyle(0, 0x00FF00);
			line.graphics.beginFill(0x00FF00,0.5);
			line.graphics.moveTo(0,GRAFT_HEIGHT);
			
			SoundMixer.computeSpectrum(byteArr);
			
			for (var i:int = 0; i < CHANNEL_SIZE; i++) {
                num = (byteArr.readFloat() * GRAFT_HEIGHT);
                line.graphics.lineTo(i * 2, GRAFT_HEIGHT - num);
            }
			
			line.graphics.lineTo(CHANNEL_SIZE * 2, GRAFT_HEIGHT);
			line.graphics.endFill();
			 
			line.graphics.lineStyle(0, 0xFF0000);
			line.graphics.beginFill(0xFF0000, 0.5);
			line.graphics.moveTo(CHANNEL_SIZE * 2,GRAFT_HEIGHT);
			 
			for (i = CHANNEL_SIZE; i > 0; i--) {
               num = (byteArr.readFloat() * GRAFT_HEIGHT);
               line.graphics.lineTo(i * 2, GRAFT_HEIGHT - num);
            }
			
			line.graphics.lineTo(0, GRAFT_HEIGHT);
            line.graphics.endFill();
		}
	}
}